import data,bullet,pymunk,pyglet
from cocos.director import director
from player import *
from npc import *
from menu import *
from pyglet.window import key
from sound import *
from cocos.actions import *
from cocos.scenes import *
import pyglet
from pyglet.gl import *
from cocos.layer import *
from cocos.text import *
from cocos.actions import *
from cocos.sprite import Sprite

class Display_text:
	def __init__(self,colorLayer,text,valueZ,label_position,time_sleep,color=(255,255,255,255)):
		self.colorLayer=colorLayer
		######################################
		self.font = {}        
		self.font['font_size'] = 22
		self.font['color'] = color
		self.font['anchor_y'] = 'top'
		self.font['anchor_x'] = 'center'
		self.font['bold']=True
		#label pos
		self.label_position=label_position
		self.label=Label(text, **self.font)
		self.colorLayer.add(self.label,valueZ)
		self.label.position=self.label_position
		self.time=0
		self.time_sleep=time_sleep
		self.label.visible=True
		
	def Update(self,dt):
		if self.time<self.time_sleep:
			self.time += dt
			return False
		elif self.label.visible:
			self.label.visible=False
			return True
		else:
			return True

class Level_1(cocos.layer.ColorLayer):
	#enable header
	is_event_handler = True
	
	def __init__(self,args,endLevel=False):
		self.endLevel = endLevel
		self.restart = True
		self.pauseScene = args['pauseScene']
		self.nextLevel = args['nextLevel']
		self.currentLevel = args['currentLevel']
		self.effects = args['effects']
		self.theend = args['theend']
		super(Level_1,self).__init__(255, 255, 255, 255)
	
	def InitGame(self):
		self.music = Sound(pathatlas+'POL-pop-corn-short.wav')
		#Clean scene
		self.unschedule(self.Update)
		for x in self.children:
			self.remove(x[1])
		
		#init physics
		self.space = pymunk.Space()
		self.space.damping = 1
		
		self.l1 = pymunk.Segment(pymunk.Body(),(0,0),(0,1024),1.0)
		self.l2 = pymunk.Segment(pymunk.Body(),(0,0),(1024,0),1.0)
		self.l3 = pymunk.Segment(pymunk.Body(),(1024,768),(1024,0),1.0)
		self.l4 = pymunk.Segment(pymunk.Body(),(1024,768),(0,768),1.0)
		
		self.l1._set_layers(1)
		self.l2._set_layers(1)
		self.l3._set_layers(1)
		self.l4._set_layers(1)
		
		self.space.add_static(self.l1,self.l2,self.l3,self.l4)
		
		# background
		self.background = cocos.sprite.Sprite(pathatlas+"level1.png")
		self.background.position = (self.width/2,self.height/2)
		self.add(self.background, z = 1)
		
		#create player     
		input_player={
						"position":(600,384),
						"image_player": pathatlas+"player.png",
						"image_bullet": pathatlas+"bullet.png",
						"weapon": Weapon(20,10,9,10),
						"image_weapon": pathatlas+"gun.png",
						"distance_weapon": (-30.0,30.0),
						"effects": self.effects,
						"range_body": 30.0,
						"scale_body": 0.15,
						"scale_weapon": 0.15
						}
		self.player=Player(self,self.space,input_player)
		#create Disably Life
		self.displayLife=DrawLife(self.player,self,(self.width-85,self.height-10))
		#create Disably Point
		self.displayPoint=DrawPoint(self.player,self,(75,self.height-10))
		# Make NPC
		self.npcs = RespawnNPC(self.space,self)
		argsGenEnemies = {
						'img' : [pathatlas+"npc.png",pathatlas+"npc_dead.png"],
						'dir' : 0,
						'n' : 30,
						'xy' : (-100.,384.),
						'range_gen' :(0,0,-512,+512),
						'route' : [(-1,-1)],
						'player' : self.player ,
						'vel' : 100,
						'seek' : 0.5,
						'time_walk' : 0.01,
						'updown' : False,
						'smooth' : True,
						'depth' : 4
						}
		
		self.enemies = self.npcs.gen_enemies(argsGenEnemies)
		######################################
		self.font = {}        
		self.font['font_size'] = 22
		self.font['color'] = (255,255,255,255)
		self.font['anchor_y'] = 'top'
		self.font['anchor_x'] = 'center'
		self.font['bold']=True
		######################################
		self.numenemieslabel=Label(str(len(self.enemies)), **self.font)
		self.numenemieslabel.position = (self.width / 2, self.height - 10)
		self.add(self.numenemieslabel, z = 15)
		#create Disably Bullet
		self.displayWeapon=DrawWeaponLite(self.player.weapon,self,100,(30,30),pathatlas+"bullet_count.png",pathatlas+"bullet_count_disable.png")
		
		#add update method
		self.schedule(self.Update)
		#add text story line
		x,y = director.get_window_size()
		self.display_text1=Display_text(self,"ACTIVETED",16,(x/2, y/2+100),5)
		self.display_text2=Display_text(self,"I'M A ROBOT",16,(x/2, y/2-60+100),1)
		self.display_text3=Display_text(self,"PROCEDURE  ACTIVATED",16,(x/2, y/2-120+100),1)
		self.display_text4=Display_text(self,"I must defend this lab!",16,(x/2, y/2-180+100),1)

	def Update(self,dt):
		self.music.play()
		if self.display_text1.Update(dt) and self.display_text2.Update(dt) and self.display_text3.Update(dt) and self.display_text4.Update(dt):
			# play music
			#update npc
			list_to_delete = []
			for x in self.enemies :
				if not self.enemies[x].update(dt) :
					list_to_delete.append(x)
			#[print len(self.enemies)
			for x in list_to_delete :
				self.enemies.pop(x)
			#update num enemies
			self.updateNumEnemies()
			#update player
			self.player.Upadate()
			#if self.player.life <= 0 :
			#	image = pyglet.image.load(pathatlas+'mouse.png')
			#	self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			#	self.cursor.drawable = True
			#	director.window.set_mouse_cursor(self.cursor)
			#updata weapon screen
			self.displayWeapon.Update()
			#update physics
			self.space.step(dt)
			#updata life screen
			self.displayLife.Update()
			#updata point screen
			self.displayPoint.Update()
			#END LEVEL
			if len(self.enemies) <= 0:
				self.unschedule(self.Update)
				if self.endLevel :
					image = pyglet.image.load(pathatlas+'mouse.png')
					self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
					self.cursor.drawable = True
					director.window.set_mouse_cursor(self.cursor)
				self.music = Sound(pathatlas+'POL-night-trip-short.wav')
				self.music.play()
				self.nextLevel.get_children()[0].player.point += self.player.point
				director.replace(FlipAngular3DTransition( self.nextLevel,2,self.currentLevel))
			if self.player.life <= 0:
				self.unschedule(self.Update)
				image = pyglet.image.load(pathatlas+'mouse.png')
				self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
				self.cursor.drawable = True
				director.window.set_mouse_cursor(self.cursor)
				self.theend.get_children()[0].component.element.text = "-> "+str(self.player.point)+" <-"
				director.replace(FlipAngular3DTransition( self.theend,2,self.currentLevel))

	def updateNumEnemies(self) :
		self.numenemieslabel.element.text = (str(len(self.enemies)))
	###############################
	#EVENT
	
	#mouse    
	def on_mouse_motion (self, x, y, dx, dy):   
		self.player.MouseMotion(x, y, dx, dy)
	def  on_mouse_press (self, x, y, buttons, modifiers):  
		self.player.MouseDown(x, y, buttons, modifiers)
	def on_mouse_release(self, x, y, buttons, modifiers):  
		self.player.MouseUp(x, y, buttons, modifiers)
	#key board    
	def on_key_press(self, k, modifiers):
		if k == key.ESCAPE :
			image = pyglet.image.load(pathatlas+'mouse.png')
			self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			self.cursor.drawable = True
			director.window.set_mouse_cursor(self.cursor)
			director.replace(FlipY3DTransition( self.pauseScene,0.5,self.currentLevel))
			return (True)
		self.player.KeyDown(k)

	def on_key_release(self, k, modifiers):
		self.player.KeyUp(k)

class Level_2(cocos.layer.ColorLayer):
	#enable header
	is_event_handler = True
	
	def __init__(self,args,endLevel=False):
		self.music = None
		self.endLevel = endLevel
		self.restart = True
		self.pauseScene = args['pauseScene']
		self.nextLevel = args['nextLevel']
		self.currentLevel = args['currentLevel']
		self.effects = args['effects']
		self.theend = args['theend']
		super(Level_2,self).__init__(255, 255, 255, 255)
	
	def InitGame(self):
		#Clean scene
		self.unschedule(self.Update)
		for x in self.children:
			self.remove(x[1])
		
		#init physics
		self.space = pymunk.Space()
		self.space.damping = 1
		
		self.l1 = pymunk.Segment(pymunk.Body(),(0,0),(0,1024),1.0)
		self.l2 = pymunk.Segment(pymunk.Body(),(0,0),(1024,0),1.0)
		self.l3 = pymunk.Segment(pymunk.Body(),(1024,768),(1024,0),1.0)
		self.l4 = pymunk.Segment(pymunk.Body(),(1024,768),(0,768),1.0)
		
		self.l1._set_layers(1)
		self.l2._set_layers(1)
		self.l3._set_layers(1)
		self.l4._set_layers(1)
		
		self.space.add_static(self.l1,self.l2,self.l3,self.l4)
		
		# background
		self.background = cocos.sprite.Sprite(pathatlas+"level2-4.png")
		self.background.position = (self.width/2,self.height/2)
		self.add(self.background, z = 1)
		
		#create player     
		input_player={
						"position":(600,350),
						"image_player": pathatlas+"player.png",
						"image_bullet": pathatlas+"bullet.png",
						"weapon": Weapon(20,10,10,0),
						"image_weapon": pathatlas+"gun.png",
						"distance_weapon": (-30.0,30.0),
						"effects": self.effects,
						"range_body": 30.0,
						"scale_body": 0.15,
						"scale_weapon": 0.15
						}
		self.player=Player(self,self.space,input_player)
		#create Disably Life
		self.displayLife=DrawLife(self.player,self,(self.width-85,self.height-10))
		#create Disably Point
		self.displayPoint=DrawPoint(self.player,self,(75,self.height-10))
		# Make NPC
		self.npcs = RespawnNPC(self.space,self)
		argsGenEnemies = {
						'img' : [pathatlas+"npc.png",pathatlas+"npc_dead.png"],
						'dir' : 0,
						'n' : 30,
						'xy' : (1124.,384.),
						'range_gen' :(0,0,-120,+120),
						'route' : [(-1,-1)],
						'player' : self.player ,
						'vel' : 100,
						'seek' : 0.5,
						'time_walk' : 0.01,
						'updown' : False,
						'smooth' : True,
						'depth' : 4
						}
		
		self.enemies = self.npcs.gen_enemies(argsGenEnemies)
		######################################
		self.font = {}        
		self.font['font_size'] = 22
		self.font['color'] = (255,255,255,255)
		self.font['anchor_y'] = 'top'
		self.font['anchor_x'] = 'center'
		self.font['bold']=True
		######################################
		self.numenemieslabel=Label(str(len(self.enemies)), **self.font)
		self.numenemieslabel.position = (self.width / 2, self.height - 10)
		self.add(self.numenemieslabel, z = 15)
		#create Disably Bullet
		self.displayWeapon=DrawWeaponLite(self.player.weapon,self,100,(30,30),pathatlas+"bullet_count.png",pathatlas+"bullet_count_disable.png")
		
		#add update method
		self.schedule(self.Update)
		#add text story line
		x,y = director.get_window_size()
		self.display_text1=Display_text(self,"WHAT A F**K?",16,(x/2, y/2+100),5)
		self.display_text2=Display_text(self,"I'M A ROBOT",16,(x/2, y/2-60+100),1)
		self.display_text3=Display_text(self,"OTHER MONSTERS????",16,(x/2, y/2-120+100),1)
		self.display_text4=Display_text(self,"PROCEDURE  ACTIVATED",16,(x/2, y/2-180+100),1)
		self.display_text5=Display_text(self,"I must defend this lab!",16,(x/2, y/2-240+100),1)

	def Update(self,dt):
		if self.display_text1.Update(dt) and self.display_text2.Update(dt) and self.display_text3.Update(dt) and self.display_text4.Update(dt)and self.display_text3.Update(dt) and self.display_text4.Update(dt) and self.display_text5.Update(dt):

			#update npc
			list_to_delete = []
			for x in self.enemies :
				if not self.enemies[x].update(dt) :
					list_to_delete.append(x)
			#[print len(self.enemies)
			for x in list_to_delete :
				self.enemies.pop(x)
			#update num enemies
			self.updateNumEnemies()
			#update player
			self.player.Upadate()
			#if self.player.life <= 0 :
			#	image = pyglet.image.load(pathatlas+'mouse.png')
			#	self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			#	self.cursor.drawable = True
			#	director.window.set_mouse_cursor(self.cursor)
			#updata weapon screen
			self.displayWeapon.Update()
			#update physics
			self.space.step(dt)
			#updata life screen
			self.displayLife.Update()
			#updata point screen
			self.displayPoint.Update()
			#END LEVEL
			if len(self.enemies) <= 0:
				self.unschedule(self.Update)
				if self.endLevel :
					image = pyglet.image.load(pathatlas+'mouse.png')
					self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
					self.cursor.drawable = True
					director.window.set_mouse_cursor(self.cursor)
				self.music = Sound(pathatlas+'POL-pop-corn-short.wav')
				self.music.play()
				self.nextLevel.get_children()[0].player.point += self.player.point
				director.replace(FlipAngular3DTransition( self.nextLevel,2,self.currentLevel))
			if self.player.life <= 0:
				self.unschedule(self.Update)
				image = pyglet.image.load(pathatlas+'mouse.png')
				self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
				self.cursor.drawable = True
				director.window.set_mouse_cursor(self.cursor)
				self.theend.get_children()[0].component.element.text = "-> "+str(self.player.point)+" <-"
				director.replace(FlipAngular3DTransition( self.theend,2,self.currentLevel))

	def updateNumEnemies(self) :
		self.numenemieslabel.element.text = (str(len(self.enemies)))
	###############################
	#EVENT
	
	#mouse    
	def on_mouse_motion (self, x, y, dx, dy):   
		self.player.MouseMotion(x, y, dx, dy)
	def  on_mouse_press (self, x, y, buttons, modifiers):  
		self.player.MouseDown(x, y, buttons, modifiers)
	def on_mouse_release(self, x, y, buttons, modifiers):  
		self.player.MouseUp(x, y, buttons, modifiers)
	#key board    
	def on_key_press(self, k, modifiers):
		if k == key.ESCAPE :
			image = pyglet.image.load(pathatlas+'mouse.png')
			self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			self.cursor.drawable = True
			director.window.set_mouse_cursor(self.cursor)
			director.replace(FlipY3DTransition( self.pauseScene,0.5,self.currentLevel))
			return (True)
		self.player.KeyDown(k)

	def on_key_release(self, k, modifiers):
		self.player.KeyUp(k)

class Level_3(cocos.layer.ColorLayer):
	#enable header
	is_event_handler = True
	
	def __init__(self,args,endLevel=False):
		self.music = None
		self.endLevel = endLevel
		self.restart = True
		self.pauseScene = args['pauseScene']
		self.nextLevel = args['nextLevel']
		self.currentLevel = args['currentLevel']
		self.effects = args['effects']
		self.theend = args['theend']
		super(Level_3,self).__init__(255, 255, 255, 255)
	
	def InitGame(self):
		#Clean scene
		self.unschedule(self.Update)
		for x in self.children:
			self.remove(x[1])
		
		#init physics
		self.space = pymunk.Space()
		self.space.damping = 1
		
		self.l1 = pymunk.Segment(pymunk.Body(),(0,0),(0,1024),1.0)
		self.l2 = pymunk.Segment(pymunk.Body(),(0,0),(1024,0),1.0)
		self.l3 = pymunk.Segment(pymunk.Body(),(1024,768),(1024,0),1.0)
		self.l4 = pymunk.Segment(pymunk.Body(),(1024,768),(0,768),1.0)
		
		self.l1._set_layers(1)
		self.l2._set_layers(1)
		self.l3._set_layers(1)
		self.l4._set_layers(1)
		
		self.space.add_static(self.l1,self.l2,self.l3,self.l4)
		
		# background
		self.background = cocos.sprite.Sprite(pathatlas+"level3.png")
		self.background.position = (self.width/2,self.height/2)
		self.add(self.background, z = 1)
		
		#create player     
		input_player={
						"position":(600,350),
						"image_player": pathatlas+"player.png",
						"image_bullet": pathatlas+"bullet.png",
						"weapon": Weapon(20,10,9,10),
						"image_weapon": pathatlas+"gun.png",
						"distance_weapon": (-30.0,30.0),
						"effects": self.effects,
						"range_body": 30.0,
						"scale_body": 0.15,
						"scale_weapon": 0.15
						}
		self.player=Player(self,self.space,input_player)
		#create Disably Life
		self.displayLife=DrawLife(self.player,self,(self.width-85,self.height-10))
		#create Disably Point
		self.displayPoint=DrawPoint(self.player,self,(75,self.height-10))
		# Make NPC
		self.npcs = RespawnNPC(self.space,self)
		argsGenEnemies = {
						'img' : [pathatlas+"npc.png",pathatlas+"npc_dead.png"],
						'dir' : 0,
						'n' : 35,
						'xy' : (1124.,384.),
						'range_gen' :(0,0,-512,+512),
						'route' : [(-1,-1)],
						'player' : self.player ,
						'vel' : 100,
						'seek' : 0.5,
						'time_walk' : 0.01,
						'updown' : False,
						'smooth' : True,
						'depth' : 4
						}
		
		self.enemies = self.npcs.gen_enemies(argsGenEnemies)
		######################################
		self.font = {}        
		self.font['font_size'] = 22
		self.font['color'] = (255,255,255,255)
		self.font['anchor_y'] = 'top'
		self.font['anchor_x'] = 'center'
		self.font['bold']=True
		######################################
		self.numenemieslabel=Label(str(len(self.enemies)), **self.font)
		self.numenemieslabel.position = (self.width / 2, self.height - 10)
		self.add(self.numenemieslabel, z = 15)
		#create Disably Bullet
		self.displayWeapon=DrawWeaponLite(self.player.weapon,self,100,(30,30),pathatlas+"bullet_count.png",pathatlas+"bullet_count_disable.png")
		
		#add update method
		self.schedule(self.Update)
		#add text story line
		x,y = director.get_window_size()

		#add text story line
		x,y = director.get_window_size()
		self.display_text1=Display_text(self,"I'M A ROBOT",16,(x/2, y/2+100),5)
		self.display_text2=Display_text(self,"PROCEDURE  ACTIVATED",16,(x/2, y/2-60+100),1)
		self.display_text3=Display_text(self,"I must defend this lab!",16,(x/2, y/2-120+100),1)
		self.display_text4=Display_text(self,"I'M A ROBOT",16,(x/2, y/2-180+100),1)

	def Update(self,dt):
		if self.display_text1.Update(dt) and self.display_text2.Update(dt) and self.display_text3.Update(dt) and self.display_text4.Update(dt):
			#update npc
			list_to_delete = []
			for x in self.enemies :
				if not self.enemies[x].update(dt) :
					list_to_delete.append(x)
			#[print len(self.enemies)
			for x in list_to_delete :
				self.enemies.pop(x)
			#update num enemies
			self.updateNumEnemies()
			#update player
			self.player.Upadate()
			#if self.player.life <= 0 :
			#	image = pyglet.image.load(pathatlas+'mouse.png')
			#	self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			#	self.cursor.drawable = True
			#	director.window.set_mouse_cursor(self.cursor)
			#updata weapon screen
			self.displayWeapon.Update()
			#update physics
			self.space.step(dt)
			#updata life screen
			self.displayLife.Update()
			#updata point screen
			self.displayPoint.Update()
			#END LEVEL
			if len(self.enemies) <= 0:
				self.unschedule(self.Update)
				if self.endLevel :
					image = pyglet.image.load(pathatlas+'mouse.png')
					self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
					self.cursor.drawable = True
					director.window.set_mouse_cursor(self.cursor)
				self.music = Sound(pathatlas+'POL-night-trip-short.wav')
				self.music.play()
				self.nextLevel.get_children()[0].player.point += self.player.point
				director.replace(FlipAngular3DTransition( self.nextLevel,2,self.currentLevel))
			if self.player.life <= 0:
				self.unschedule(self.Update)
				image = pyglet.image.load(pathatlas+'mouse.png')
				self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
				self.cursor.drawable = True
				director.window.set_mouse_cursor(self.cursor)
				self.theend.get_children()[0].component.element.text = "-> "+str(self.player.point)+" <-"
				director.replace(FlipAngular3DTransition( self.theend,2,self.currentLevel))

	def updateNumEnemies(self) :
		self.numenemieslabel.element.text = (str(len(self.enemies)))
	###############################
	#EVENT
	
	#mouse    
	def on_mouse_motion (self, x, y, dx, dy):   
		self.player.MouseMotion(x, y, dx, dy)
	def  on_mouse_press (self, x, y, buttons, modifiers):  
		self.player.MouseDown(x, y, buttons, modifiers)
	def on_mouse_release(self, x, y, buttons, modifiers):  
		self.player.MouseUp(x, y, buttons, modifiers)
	#key board    
	def on_key_press(self, k, modifiers):
		if k == key.ESCAPE :
			image = pyglet.image.load(pathatlas+'mouse.png')
			self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			self.cursor.drawable = True
			director.window.set_mouse_cursor(self.cursor)
			director.replace(FlipY3DTransition( self.pauseScene,0.5,self.currentLevel))
			return (True)
		self.player.KeyDown(k)

	def on_key_release(self, k, modifiers):
		self.player.KeyUp(k)

class Level_4(cocos.layer.ColorLayer):
	#enable header
	is_event_handler = True
	
	def __init__(self,args,endLevel=False):
		self.music = None
		self.endLevel = endLevel
		self.restart = True
		self.pauseScene = args['pauseScene']
		self.nextLevel = args['nextLevel']
		self.currentLevel = args['currentLevel']
		self.effects = args['effects']
		self.theend = args['theend']
		super(Level_4,self).__init__(255, 255, 255, 255)
	
	def InitGame(self):
		#Clean scene
		self.unschedule(self.Update)
		for x in self.children:
			self.remove(x[1])
		
		#init physics
		self.space = pymunk.Space()
		self.space.damping = 1
		
		self.l1 = pymunk.Segment(pymunk.Body(),(0,0),(0,1024),1.0)
		self.l2 = pymunk.Segment(pymunk.Body(),(0,0),(1024,0),1.0)
		self.l3 = pymunk.Segment(pymunk.Body(),(1024,768),(1024,0),1.0)
		self.l4 = pymunk.Segment(pymunk.Body(),(1024,768),(0,768),1.0)
		
		self.l1._set_layers(1)
		self.l2._set_layers(1)
		self.l3._set_layers(1)
		self.l4._set_layers(1)
		
		self.space.add_static(self.l1,self.l2,self.l3,self.l4)
		
		# background
		self.background = cocos.sprite.Sprite(pathatlas+"level2-4.png")
		self.background.position = (self.width/2,self.height/2)
		self.add(self.background, z = 1)
		
		#create player     
		input_player={
						"position":(600,350),
						"image_player": pathatlas+"player.png",
						"image_bullet": pathatlas+"bullet.png",
						"weapon": Weapon(20,10,9,10),
						"image_weapon": pathatlas+"gun.png",
						"distance_weapon": (-30.0,30.0),
						"effects": self.effects,
						"range_body": 30.0,
						"scale_body": 0.15,
						"scale_weapon": 0.15
						}
		self.player=Player(self,self.space,input_player)
		#create Disably Life
		self.displayLife=DrawLife(self.player,self,(self.width-85,self.height-10))
		#create Disably Point
		self.displayPoint=DrawPoint(self.player,self,(75,self.height-10))
		# Make NPC
		self.npcs = RespawnNPC(self.space,self)
		argsGenEnemies = {
						'img' : [pathatlas+"npc.png",pathatlas+"npc_dead.png"],
						'dir' : 0,
						'n' : 12,
						'xy' : (-100.,384.),
						'range_gen' :(0,0,-120,+120),
						'route' : [(-1,-1)],
						'player' : self.player ,
						'vel' : 100,
						'seek' : 0.5,
						'time_walk' : 0.01,
						'updown' : False,
						'smooth' : True,
						'depth' : 4
						}
		
		self.enemies = self.npcs.gen_enemies(argsGenEnemies)
		
		argsGenEnemies['xy'] = (1150,384)
		
		self.enemies.update(self.npcs.gen_enemies(argsGenEnemies))
		
		######################################
		self.font = {}        
		self.font['font_size'] = 22
		self.font['color'] = (255,255,255,255)
		self.font['anchor_y'] = 'top'
		self.font['anchor_x'] = 'center'
		self.font['bold']=True
		######################################
		self.numenemieslabel=Label(str(len(self.enemies)), **self.font)
		self.numenemieslabel.position = (self.width / 2, self.height - 10)
		self.add(self.numenemieslabel, z = 15)
		#create Disably Bullet
		self.displayWeapon=DrawWeaponLite(self.player.weapon,self,100,(30,30),pathatlas+"bullet_count.png",pathatlas+"bullet_count_disable.png")
		
		#add update method
		self.schedule(self.Update)
		#add text story line
		x,y = director.get_window_size()
		self.display_text1=Display_text(self,"Are too many!",16,(x/2, y/2+100),5)
		self.display_text2=Display_text(self,"BUT I'M A ROBOT",16,(x/2, y/2-60+100),1)
		self.display_text3=Display_text(self,"PROCEDURE  ACTIVATED",16,(x/2, y/2-120+100),1)
		self.display_text4=Display_text(self,"I must defend this lab!",16,(x/2, y/2-180+100),1)

	def Update(self,dt):
		if self.display_text1.Update(dt) and self.display_text2.Update(dt) and self.display_text3.Update(dt) and self.display_text4.Update(dt):
			#update npc
			list_to_delete = []
			for x in self.enemies :
				if not self.enemies[x].update(dt) :
					list_to_delete.append(x)
			#[print len(self.enemies)
			for x in list_to_delete :
				self.enemies.pop(x)
			#update num enemies
			self.updateNumEnemies()
			#update player
			self.player.Upadate()
			#if self.player.life <= 0 :
			#	image = pyglet.image.load(pathatlas+'mouse.png')
			#	self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			#	self.cursor.drawable = True
			#	director.window.set_mouse_cursor(self.cursor)
			#updata weapon screen
			self.displayWeapon.Update()
			#update physics
			self.space.step(dt)
			#updata life screen
			self.displayLife.Update()
			#updata point screen
			self.displayPoint.Update()
			#END LEVEL
			if len(self.enemies) <= 0:
				self.unschedule(self.Update)
				if self.endLevel :
					image = pyglet.image.load(pathatlas+'mouse.png')
					self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
					self.cursor.drawable = True
					director.window.set_mouse_cursor(self.cursor)
				self.music = Sound(pathatlas+'POL-at-dawn-short.wav')
				self.music.play()
				self.nextLevel.get_children()[0].player.point += self.player.point
				director.replace(FlipAngular3DTransition( self.nextLevel,2,self.currentLevel))
			if self.player.life <= 0:
				self.unschedule(self.Update)
				image = pyglet.image.load(pathatlas+'mouse.png')
				self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
				self.cursor.drawable = True
				director.window.set_mouse_cursor(self.cursor)
				self.theend.get_children()[0].component.element.text = "-> "+str(self.player.point)+" <-"
				director.replace(FlipAngular3DTransition( self.theend,2,self.currentLevel))

	def updateNumEnemies(self) :
		self.numenemieslabel.element.text = (str(len(self.enemies)))
	###############################
	#EVENT
	
	#mouse    
	def on_mouse_motion (self, x, y, dx, dy):   
		self.player.MouseMotion(x, y, dx, dy)
	def  on_mouse_press (self, x, y, buttons, modifiers):  
		self.player.MouseDown(x, y, buttons, modifiers)
	def on_mouse_release(self, x, y, buttons, modifiers):  
		self.player.MouseUp(x, y, buttons, modifiers)
	#key board    
	def on_key_press(self, k, modifiers):
		if k == key.ESCAPE :
			image = pyglet.image.load(pathatlas+'mouse.png')
			self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			self.cursor.drawable = True
			director.window.set_mouse_cursor(self.cursor)
			director.replace(FlipY3DTransition( self.pauseScene,0.5,self.currentLevel))
			return (True)
		self.player.KeyDown(k)

	def on_key_release(self, k, modifiers):
		self.player.KeyUp(k)
	
class Level_5(cocos.layer.ColorLayer):
	#enable header
	is_event_handler = True
	
	def __init__(self,args,endLevel=False):
		self.music = None
		self.endLevel = endLevel
		self.restart = True
		self.pauseScene = args['pauseScene']
		self.nextLevel = args['nextLevel']
		self.currentLevel = args['currentLevel']
		self.effects = args['effects']
		self.theend = args['theend']
		super(Level_5,self).__init__(255, 255, 255, 255)
	
	def InitGame(self):
		#Clean scene
		self.unschedule(self.Update)
		for x in self.children:
			self.remove(x[1])
		
		#init physics
		self.space = pymunk.Space()
		self.space.damping = 1
		
		self.l1 = pymunk.Segment(pymunk.Body(),(0,0),(0,1024),1.0)
		self.l2 = pymunk.Segment(pymunk.Body(),(0,0),(1024,0),1.0)
		self.l3 = pymunk.Segment(pymunk.Body(),(1024,768),(1024,0),1.0)
		self.l4 = pymunk.Segment(pymunk.Body(),(1024,768),(0,768),1.0)
		
		self.l1._set_layers(1)
		self.l2._set_layers(1)
		self.l3._set_layers(1)
		self.l4._set_layers(1)
		
		self.space.add_static(self.l1,self.l2,self.l3,self.l4)
		
		# background
		self.background = cocos.sprite.Sprite(pathatlas+"level5.png")
		self.background.position = (self.width/2,self.height/2)
		self.add(self.background, z = 1)
		
		#create player     
		input_player={
						"position":(600,350),
						"image_player": pathatlas+"player.png",
						"image_bullet": pathatlas+"bullet.png",
						"weapon": Weapon(20,10,9,10),
						"image_weapon": pathatlas+"gun.png",
						"distance_weapon": (-30.0,30.0),
						"effects": self.effects,
						"range_body": 30.0,
						"scale_body": 0.15,
						"scale_weapon": 0.15
						}
		self.player=Player(self,self.space,input_player)
		#create Disably Life
		self.displayLife=DrawLife(self.player,self,(self.width-85,self.height-10))
		#create Disably Point
		self.displayPoint=DrawPoint(self.player,self,(75,self.height-10))
		# Make NPC
		self.npcs = RespawnNPC(self.space,self)
		
		argsGenEnemies = {
						'img' : [pathatlas+"npc.png",pathatlas+"npc_dead.png"],
						'dir' : 0,
						'n' : 11,
						'xy' : (-100.,384.),
						'range_gen' :(0,0,-300,+300),
						'route' : [(-1,-1)],
						'player' : self.player ,
						'vel' : 100,
						'seek' : 0.5,
						'time_walk' : 0.01,
						'updown' : False,
						'smooth' : True,
						'depth' : 4
						}
		
		self.enemies = self.npcs.gen_enemies(argsGenEnemies)
		
		argsGenEnemies['xy'] = (1200.,384.)
		
		self.enemies.update(self.npcs.gen_enemies(argsGenEnemies))
		
		argsGenEnemies['xy'] = (300.,1050.)
		
		self.enemies.update(self.npcs.gen_enemies(argsGenEnemies))
		
		argsGenEnemies['xy'] = (300.,-320.)
		
		self.enemies.update(self.npcs.gen_enemies(argsGenEnemies))
		######################################
		self.font = {}        
		self.font['font_size'] = 22
		self.font['color'] = (255,255,255,255)
		self.font['anchor_y'] = 'top'
		self.font['anchor_x'] = 'center'
		self.font['bold']=True
		######################################
		self.numenemieslabel=Label(str(len(self.enemies)), **self.font)
		self.numenemieslabel.position = (self.width / 2, self.height - 10)
		self.add(self.numenemieslabel, z = 15)
		#create Disably Bullet
		self.displayWeapon=DrawWeaponLite(self.player.weapon,self,100,(30,30),pathatlas+"bullet_count.png",pathatlas+"bullet_count_disable.png")
		
		#add update method
		self.schedule(self.Update)
		#add text story line
		x,y = director.get_window_size()
		self.display_text1=Display_text(self,"This is the last place where I can destroy all monsters!",16,(x/2, y/2+100),5,(255,0,0,255))
		self.display_text2=Display_text(self,"I'M A ROBOT",16,(x/2, y/2-60+100),1,(255,0,0,255))
		self.display_text3=Display_text(self,"PROCEDURE  ACTIVATED",16,(x/2, y/2-120+100),1,(255,0,0,255))
		self.display_text4=Display_text(self,"I must clean this area!",16,(x/2, y/2-180+100),1,(255,0,0,255))

	def Update(self,dt):
		if self.display_text1.Update(dt) and self.display_text2.Update(dt) and self.display_text3.Update(dt) and self.display_text4.Update(dt):

			#update npc
			list_to_delete = []
			for x in self.enemies :
				if not self.enemies[x].update(dt) :
					list_to_delete.append(x)
			#[print len(self.enemies)
			for x in list_to_delete :
				self.enemies.pop(x)
			#update num enemies
			self.updateNumEnemies()
			#update player
			self.player.Upadate()
			#if self.player.life <= 0 :
			#	image = pyglet.image.load(pathatlas+'mouse.png')
			#	self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			#	self.cursor.drawable = True
			#	director.window.set_mouse_cursor(self.cursor)
			#updata weapon screen
			self.displayWeapon.Update()
			#update physics
			self.space.step(dt)
			#updata life screen
			self.displayLife.Update()
			#updata point screen
			self.displayPoint.Update()
			#END LEVEL
			if len(self.enemies) <= 0:
				self.unschedule(self.Update)
				if self.endLevel :
					image = pyglet.image.load(pathatlas+'mouse.png')
					self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
					self.cursor.drawable = True
					director.window.set_mouse_cursor(self.cursor)
				#self.nextLevel.get_children()[0].player.point += self.player.point
				self.theend.get_children()[0].component.element.text = "-> "+str(self.player.point)+" <-"
				director.replace(FlipAngular3DTransition( self.nextLevel,2,self.currentLevel))
			if self.player.life <= 0:
				self.unschedule(self.Update)
				image = pyglet.image.load(pathatlas+'mouse.png')
				self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
				self.cursor.drawable = True
				director.window.set_mouse_cursor(self.cursor)
				self.theend.get_children()[0].component.element.text = "-> "+str(self.player.point)+" <-"
				director.replace(FlipAngular3DTransition( self.theend,2,self.currentLevel))

	def updateNumEnemies(self) :
		self.numenemieslabel.element.text = (str(len(self.enemies)))
	###############################
	#EVENT
	
	#mouse    
	def on_mouse_motion (self, x, y, dx, dy):   
		self.player.MouseMotion(x, y, dx, dy)
	def  on_mouse_press (self, x, y, buttons, modifiers):  
		self.player.MouseDown(x, y, buttons, modifiers)
	def on_mouse_release(self, x, y, buttons, modifiers):  
		self.player.MouseUp(x, y, buttons, modifiers)
	#key board    
	def on_key_press(self, k, modifiers):
		if k == key.ESCAPE :
			image = pyglet.image.load(pathatlas+'mouse.png')
			self.cursor = pyglet.window.ImageMouseCursor(image, 0, 24)
			self.cursor.drawable = True
			director.window.set_mouse_cursor(self.cursor)
			director.replace(FlipY3DTransition( self.pauseScene,0.5,self.currentLevel))
			return (True)
		self.player.KeyDown(k)

	def on_key_release(self, k, modifiers):
		self.player.KeyUp(k)